using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Chart;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private double[] cpuData = null;
		private System.Windows.Forms.Timer timer1;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.GroupBox groupBox1;
		static int count = 100;

		public Form1()
		{
			cpuData = new double[count];
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.BackColor = System.Drawing.Color.Transparent;
			this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Syncfusion.Drawing.BrushInfoColorArrayList(new System.Drawing.Color[] {
																																																	 System.Drawing.Color.Black,
																																																	 System.Drawing.Color.FromArgb(((System.Byte)(55)), ((System.Byte)(245)), ((System.Byte)(245)), ((System.Byte)(220)))}));
			this.chartControl1.Location = new System.Drawing.Point(8, 16);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.GridLineType.ForeColor = System.Drawing.Color.Green;
		//	this.chartControl1.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControl1.PrimaryYAxis.GridLineType.ForeColor = System.Drawing.Color.Green;
			this.chartControl1.Size = new System.Drawing.Size(480, 144);
			this.chartControl1.TabIndex = 0;
			// 
			// timer1
			// 
			this.timer1.Enabled = true;
			this.timer1.Interval = 1000;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.chartControl1});
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(512, 168);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "CPU Usage History";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 182);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.groupBox1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "CPU Usage";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();
			InitializeChartAppearance();
		}

		/// <summary>
		/// Initializes the ChartControl's data and sets the Chart type
		/// </summary>
		protected void InitializeChartData()
		{
			ChartSeries series = this.chartControl1.Model.NewSeries("Simple Series");
			series.Text = series.Name;
			FillCPUData();
			series.SeriesIndexedModelImpl = new ArrayModel(this.cpuData);
			series.Type = ChartSeriesType.Line;
			this.chartControl1.Series.Add(series);

		}

		protected void InitializeChartAppearance()
		{
			this.chartControl1.PrimaryYAxis.RangeType = ChartAxisRangeType.Set;
			this.chartControl1.PrimaryYAxis.Range.Max = 100;
			this.chartControl1.PrimaryYAxis.Range.Min = 0;
			this.chartControl1.PrimaryYAxis.Range.Interval = 20;

			this.chartControl1.PrimaryYAxis.ValueType = ChartValueType.Custom;
			this.chartControl1.PrimaryYAxis.AutoValueType = false; // otherwise chart will assign value type based on data

			// assign custom labels for display
			this.chartControl1.PrimaryYAxis.LabelsImpl = new ChartAxisLabelModel( new string[]{});

			this.chartControl1.PrimaryXAxis.RangeType = ChartAxisRangeType.Set;
			this.chartControl1.PrimaryXAxis.Range.Max = count;
			this.chartControl1.PrimaryXAxis.Range.Min = 0;
			this.chartControl1.PrimaryXAxis.Range.Interval = 5;

			this.chartControl1.PrimaryXAxis.ValueType = ChartValueType.Custom;
			this.chartControl1.PrimaryXAxis.AutoValueType = false; // otherwise chart will assign value type based on data

			// assign custom labels for display
			this.chartControl1.PrimaryXAxis.LabelsImpl = new ChartAxisLabelModel( new string[]{});

			this.chartControl1.Series[0].Style.Interior = new BrushInfo(GradientStyle.None,Color.GreenYellow, Color.GreenYellow);
			this.chartControl1.Series[0].Style.Border.Color = Color.GreenYellow;
			this.chartControl1.Series[0].Style.Border.Width = 2;

			this.chartControl1.LegendPosition = ChartDock.Top;

			this.chartControl1.Text = "";
			this.chartControl1.Legend.Visible = false;
			this.chartControl1.ChartAreaShadow = false;
		}

		private void FillCPUData()
		{
			for(int i = 0; i <count-1; i++)
			{
				this.cpuData[i] = this.cpuData[i+1];
			}
			this.cpuData[count-1] = GetCPUUsage();
		}

		private double GetCPUUsage()
		{
			System.Diagnostics.PerformanceCounter perfCounter = new  System.Diagnostics.PerformanceCounter();
			perfCounter.CategoryName = "Processor";
			perfCounter.MachineName = ".";
			perfCounter.CounterName = "% Processor Time";
			perfCounter.InstanceName = "_Total";
			float fCpuUsage = perfCounter.NextValue();
			Thread.Sleep(100);
			fCpuUsage = perfCounter.NextValue();
			double cpuUsage = fCpuUsage;
			perfCounter.Close();
			return cpuUsage;
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			this.FillCPUData();
			ArrayModel model = this.chartControl1.Series[0].SeriesIndexedModelImpl as ArrayModel;
			model.Data = this.cpuData;
			model.RaiseListChanged();
		}
		

	}
}
